using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.IO;

namespace GeoXplore
{
	/// <summary>
	/// Summary description for GeoDataFormatInstruction.
	/// </summary>
	public class GeoDataFormatInstruction : System.Windows.Forms.Form
	{
		
		string     outFile;			//name of output data file
		
		char						NewLine			= (char)13;
		char						Return			= (char)10;

		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public GeoDataFormatInstruction()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			this.textBox1.AppendText(" " + NewLine + Return);
			this.textBox1.AppendText("		      Data Format Instructions " + NewLine + Return + NewLine + Return);
			this.textBox1.AppendText("  File Formats [all files are comma delimited - no spaces anywhere] " + NewLine + Return);
			this.textBox1.AppendText(" " + NewLine + Return);
			this.textBox1.AppendText("  1. Training Input Data Files (use this data to train the classifiers) "+ NewLine + Return);
			this.textBox1.AppendText("      N			#number of features in each vector." + NewLine + Return);
			this.textBox1.AppendText("      M			#dummy number, but necessary (integer)." + NewLine + Return);
			this.textBox1.AppendText("      J			#always set to 1 (integer)." + NewLine + Return);
			this.textBox1.AppendText("      Q			#number of vectors in this file (integer)." + NewLine + Return);
			this.textBox1.AppendText("      1,2,d,x11,x21,...,xN1,D	#first column is vector number (integer). " + NewLine + Return);
			this.textBox1.AppendText("      2,0,d,x12,x22,...,xN2,D	#second column is a dummy colum(integer). " + NewLine + Return);
			this.textBox1.AppendText("      -------------------------	#third column values are dummies, necessary" + NewLine + Return);
			this.textBox1.AppendText("      -------------------------	#fourth through fourth+N columns are N features (float)" + NewLine + Return);
			this.textBox1.AppendText("      Q,0,d,x1Q,x2Q,...,xNQ,D	#last column is fuzzy truth column " + NewLine + Return);
			this.textBox1.AppendText(" " + NewLine + Return);

			this.textBox1.AppendText("  2. Classification Input Data Files (data to be classified) "+ NewLine + Return);
			this.textBox1.AppendText("      N			#number of features in each vector." + NewLine + Return);
			this.textBox1.AppendText("      M			#dummy number, but necessary (integer)." + NewLine + Return);
			this.textBox1.AppendText("      J			#always set to 1 (integer)." + NewLine + Return);
			this.textBox1.AppendText("      Q			#number of vectors in this file (integer)." + NewLine + Return);
			this.textBox1.AppendText("     1,d1,d2,x11,x21,...,xN1,D	#first column is vector number (integer). " + NewLine + Return);
			this.textBox1.AppendText("     2,d1,d2,x12,x22,...,xN2,D	#second and third columns are dummies. " + NewLine + Return);
			this.textBox1.AppendText("     -------------------------	#fourth through fourth+N columns are N features (float)" + NewLine + Return);
			this.textBox1.AppendText("     Q,d1,d2,x1Q,x2Q,...,xNQ,D	#last column is a dummy column " + NewLine + Return);
			this.textBox1.AppendText(" " + NewLine + Return);
			
			this.textBox1.AppendText("  3. Output Classification Data Files (results of classification) "+ NewLine + Return);
			this.textBox1.AppendText("     1,2,g1			#first column is vector number." + NewLine + Return);
			this.textBox1.AppendText("     2,0,g2			#second column is the class number." + NewLine + Return);
			this.textBox1.AppendText("     ------			#third column is the belief, or goodness of the classification." + NewLine + Return); 
			this.textBox1.AppendText("     Q,1,gQ               ");

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(GeoDataFormatInstruction));
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.BackColor = System.Drawing.Color.Transparent;
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button1.Font = new System.Drawing.Font("Times New Roman", 11.25F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.ForeColor = System.Drawing.Color.SeaShell;
			this.button1.Location = new System.Drawing.Point(96, 352);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(210, 32);
			this.button1.TabIndex = 24;
			this.button1.Text = "Save instructions to file";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.BackColor = System.Drawing.Color.Transparent;
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button2.Font = new System.Drawing.Font("Times New Roman", 11.25F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button2.ForeColor = System.Drawing.Color.SeaShell;
			this.button2.Location = new System.Drawing.Point(424, 352);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(96, 32);
			this.button2.TabIndex = 25;
			this.button2.Text = "Return";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// textBox1
			// 
			this.textBox1.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
			this.textBox1.Font = new System.Drawing.Font("Times New Roman", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox1.Location = new System.Drawing.Point(32, 40);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox1.Size = new System.Drawing.Size(592, 288);
			this.textBox1.TabIndex = 26;
			this.textBox1.Text = "";
			// 
			// GeoDataFormatInstruction
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(648, 406);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Font = new System.Drawing.Font("Times New Roman", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "GeoDataFormatInstruction";
			this.Text = "GeoXplore Data Format Instructions";
			this.ResumeLayout(false);

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			saveFileDialog1.Filter = "DataFormat Files (*.DataFormat)|*.DataFormat|All files (*.*)|*.*" ;
			
			if (saveFileDialog1.ShowDialog() == DialogResult.OK)
			{	
				
				//textBox1.Text = saveFileDialog1.FileName;
			
				// get name of selected output file
				outFile = saveFileDialog1.FileName;

				// define stream buffer and open file to read in 
				FileStream outStream = new FileStream(outFile,FileMode.OpenOrCreate);

				// define writer to write stream to output file
				StreamWriter writer = new StreamWriter(outStream,Encoding.ASCII);

				// write text in textBox1 to file			
				writer.Write(textBox1.Text);

				// close output stream
				writer.Close();
				outStream.Close();
			}
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
