using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.IO;

namespace GeoXplore
{
	/// <summary>
	/// Summary description for ApplyPNN.
	/// </summary>
	public class PNN : System.Windows.Forms.Form
	{
		public static int						N;				//number features/components in each feature vector
		public static int						K;				//number initial clusters to start clustering
		public static int						J;				//number components in label vectors
		public static int						Q;				//number of feature vectors in data file
		double maxfuzzyfunction;
		double MSE,SSE;
		double sumerror;
		public static int						g,q,qq,r,j,m,n,k;	
		public static int						checkit1,checkit2;
		public static double					dist,Dist;
		public static double                    maxp;
		public static int						checkstatus;
		public static int						TotalVectors;
		public static double                    dave,denu,part;
		public static double					sum;        
		public static double					sigma;				
		
		public static double[]                  fuzzytruth		 = new double[1000];		
		public static int[,]					vect             = new int[100,1000];
		public static double[]                  fuzzyValue		 = new double[1000];
		public static double[,]					t	             = new double[1000,15];			//label: t[j][q], read but don't use in clustering
		public static double[,]					x                = new double[1000,50];		//x[n][q] = component n of feature vector q
		public static double[,]					v				 = new double[1000,50];    //v[n][k] = component n of cluster k center		
		double[]								p                = new double[1000];
		double[]								FitCluster       = new double[1000]; 		
		
		char									NewLine			= (char)13;
		char									Return			= (char)10;
		
		public static string					inFile1;				//names of input data files
		public static string					outFile;						//name of output data file

		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.TextBox textBox3;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Button button6;
		private System.Windows.Forms.TextBox textBox4;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.OpenFileDialog openFileDialog2;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button button7;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
      
		public PNN()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PNN));
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.button1 = new System.Windows.Forms.Button();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.button2 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.button4 = new System.Windows.Forms.Button();
			this.textBox3 = new System.Windows.Forms.TextBox();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.button6 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.button7 = new System.Windows.Forms.Button();
			this.label3 = new System.Windows.Forms.Label();
			this.textBox4 = new System.Windows.Forms.TextBox();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.openFileDialog2 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox5.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBox1
			// 
			this.groupBox1.BackColor = System.Drawing.Color.Transparent;
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox1.Location = new System.Drawing.Point(16, 32);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(296, 64);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Step 1: Read Instruction Before Processing Data!";
			this.groupBox1.Enter += new System.EventHandler(this.groupBox1_Enter);
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button1.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.ForeColor = System.Drawing.Color.Black;
			this.button1.Location = new System.Drawing.Point(96, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 24);
			this.button1.TabIndex = 0;
			this.button1.Text = "Instructions";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.BackColor = System.Drawing.Color.Transparent;
			this.groupBox2.Controls.Add(this.button2);
			this.groupBox2.Controls.Add(this.textBox1);
			this.groupBox2.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox2.Location = new System.Drawing.Point(16, 112);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(296, 64);
			this.groupBox2.TabIndex = 1;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Step 2: Input Training Data File !";
			this.groupBox2.Enter += new System.EventHandler(this.groupBox2_Enter);
			// 
			// button2
			// 
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button2.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button2.ForeColor = System.Drawing.Color.Black;
			this.button2.Location = new System.Drawing.Point(208, 24);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(72, 23);
			this.button2.TabIndex = 1;
			this.button2.Text = "Load File";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(16, 24);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(176, 22);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// groupBox4
			// 
			this.groupBox4.BackColor = System.Drawing.Color.Transparent;
			this.groupBox4.Controls.Add(this.button4);
			this.groupBox4.Controls.Add(this.textBox3);
			this.groupBox4.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox4.Location = new System.Drawing.Point(16, 192);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(296, 64);
			this.groupBox4.TabIndex = 3;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Step 3: Select Path and Name for Training Result !";
			this.groupBox4.Enter += new System.EventHandler(this.groupBox4_Enter);
			// 
			// button4
			// 
			this.button4.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button4.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button4.ForeColor = System.Drawing.Color.Black;
			this.button4.Location = new System.Drawing.Point(208, 24);
			this.button4.Name = "button4";
			this.button4.TabIndex = 1;
			this.button4.Text = "Save As";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// textBox3
			// 
			this.textBox3.Location = new System.Drawing.Point(16, 24);
			this.textBox3.Name = "textBox3";
			this.textBox3.Size = new System.Drawing.Size(176, 22);
			this.textBox3.TabIndex = 0;
			this.textBox3.Text = "";
			// 
			// groupBox5
			// 
			this.groupBox5.BackColor = System.Drawing.Color.Transparent;
			this.groupBox5.Controls.Add(this.label4);
			this.groupBox5.Controls.Add(this.label2);
			this.groupBox5.Controls.Add(this.button6);
			this.groupBox5.Controls.Add(this.button5);
			this.groupBox5.Controls.Add(this.button7);
			this.groupBox5.Controls.Add(this.label3);
			this.groupBox5.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox5.ForeColor = System.Drawing.Color.Black;
			this.groupBox5.Location = new System.Drawing.Point(16, 272);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(296, 128);
			this.groupBox5.TabIndex = 4;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "Step 4: Train Probabilistic Neural Network !";
			this.groupBox5.Enter += new System.EventHandler(this.groupBox5_Enter);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 88);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(24, 16);
			this.label4.TabIndex = 18;
			this.label4.Text = "[3]";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(24, 16);
			this.label2.TabIndex = 17;
			this.label2.Text = "[1]";
			// 
			// button6
			// 
			this.button6.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button6.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button6.ForeColor = System.Drawing.Color.Black;
			this.button6.Location = new System.Drawing.Point(64, 88);
			this.button6.Name = "button6";
			this.button6.Size = new System.Drawing.Size(144, 23);
			this.button6.TabIndex = 1;
			this.button6.Text = "Return";
			this.button6.Click += new System.EventHandler(this.button6_Click);
			// 
			// button5
			// 
			this.button5.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button5.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button5.ForeColor = System.Drawing.Color.Black;
			this.button5.Location = new System.Drawing.Point(64, 24);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(144, 23);
			this.button5.TabIndex = 0;
			this.button5.Text = "Run";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// button7
			// 
			this.button7.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button7.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button7.ForeColor = System.Drawing.Color.Black;
			this.button7.Location = new System.Drawing.Point(64, 56);
			this.button7.Name = "button7";
			this.button7.Size = new System.Drawing.Size(144, 24);
			this.button7.TabIndex = 16;
			this.button7.Text = "Save Training Results";
			this.button7.Click += new System.EventHandler(this.button7_Click);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 56);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(24, 16);
			this.label3.TabIndex = 16;
			this.label3.Text = "[2]";
			// 
			// textBox4
			// 
			this.textBox4.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
			this.textBox4.Font = new System.Drawing.Font("Times New Roman", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox4.Location = new System.Drawing.Point(344, 64);
			this.textBox4.Multiline = true;
			this.textBox4.Name = "textBox4";
			this.textBox4.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox4.Size = new System.Drawing.Size(424, 336);
			this.textBox4.TabIndex = 5;
			this.textBox4.Text = "";
			this.textBox4.TextChanged += new System.EventHandler(this.textBox4_TextChanged);
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialog1_FileOk);
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.Color.Transparent;
			this.label1.Font = new System.Drawing.Font("Times New Roman", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(376, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(352, 23);
			this.label1.TabIndex = 15;
			this.label1.Text = " The PNN training results will  be shown in this box";
			// 
			// PNN
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(800, 460);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.textBox4);
			this.Controls.Add(this.groupBox5);
			this.Controls.Add(this.groupBox4);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "PNN";
			this.Text = "Probabilistic Neural Network";
			this.Load += new System.EventHandler(this.PNN_Load);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void groupBox5_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void groupBox4_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void groupBox2_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void PNN_Load(object sender, System.EventArgs e)
		{
		
		}

		private void groupBox3_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void button6_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			string intText1;

			openFileDialog1.Filter = "dta Files (*.dta)|*.dta|All files (*.*)|*.*" ;

			if(openFileDialog1.ShowDialog() == DialogResult.OK)
			{						
				textBox1.Text = openFileDialog1.FileName;
				inFile1 = openFileDialog1.FileName;
				//define stream buffer and open file for reading 
				FileStream inStream = new FileStream(inFile1,FileMode.Open, 
					FileAccess.Read,FileShare.None);
				//define a variable for reading stream to
				StreamReader reader = new StreamReader(inStream, Encoding.ASCII);

				//start at beginning of input file again
				inStream.Seek(0,SeekOrigin.Begin);
				
				//read single string value: each is on a different file line
				//convert each string into an integer
				
				textBox4.Clear();
												
				intText1 = reader.ReadLine();
				N = int.Parse(intText1);	

				intText1 = reader.ReadLine();
				K = int.Parse(intText1);
				K = 1;

				intText1 = reader.ReadLine();
				J = int.Parse(intText1);
				
				intText1 = reader.ReadLine();
				Q = int.Parse(intText1);	
							
				string [] strArray;			
				char[] charArray = new char[] {','};					
				
				int q,j;
				
				for (q = 0; q < Q; q++)
				{
					intText1 = reader.ReadLine();
					strArray = intText1.Split(charArray);
					//-----------demonstrate the input data----------------
					//this.textBox4.AppendText(intText1+ NewLine + Return);	
				
					//---------------------begin to read data--------------
					
					for (j=0;j<J;j++)
					{
						t[q,j]=Convert.ToDouble(strArray[1]);						

					}

					n = 0;
					
					for (m = 3;m<strArray.Length-1;m++)
					{									
						//y[q,m] = Convert.ToDouble(strArray[m]);	
						
						x[q,n] = Convert.ToDouble(strArray[m]);
					   
						//x[q,n] = y[q,m];
										
						n++;					
					}					
					
					fuzzytruth[q]=Convert.ToDouble(strArray[strArray.Length-1]);						

								
				}  // end of "for q = 0;q<Q " loop	

							
				this.textBox4.AppendText(" Training data file has been read successfully ! " + NewLine + Return+ NewLine + Return );
				this.textBox4.AppendText("" + textBox1.Text + NewLine + Return+NewLine + Return);
				this.textBox4.AppendText(" Please go to Step 3 ! ");
				reader.Close();
				inStream.Close();

				checkit1 =1;
			}

			else checkit1 =0;
		
			
		}
	

		private void openFileDialog1_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
		
		}

		private void textBox4_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			double threshold = 0.55;
			
			double MinGoodness = 9999.99;

			double MaxGoodness = 0;

			

			
			if ((checkit1 ==1)&&(checkit2==1))
			{
				textBox4.Clear();

				PNNParameter dlg = new PNNParameter();
				dlg.ShowDialog();

				//--------------Classify the input vectors according its label------
				int i,ii;							 
				
				i=0;
				TotalVectors = 0;

				for (q=0;q<Q;q++)
				{ 	    
					for (j=0;j<J;j++)
					{ 		
						if (fuzzytruth[q] > threshold)
						{
							for (n=0;n<N;n++)
							{
								v[i,n]=x[q,n];		//set the value for the vector in cluster
							
							     fuzzyValue[i] = fuzzytruth[q];								
							}
							i++;
							TotalVectors++;
													
						}//if (fuzzytruth[q] > threshold)
					}//for (j=0;j<J;j++)
				}// end for for (q=0;q<Q;q++)
				//this.textBox4.AppendText(Convert.ToString(TotalVectors)+ NewLine +Return);
							
				double maxinputfuzzytruth = 0;
				
				for (q=0;q<Q;q++)
				{				
					if (fuzzytruth[q]>maxinputfuzzytruth)
					{
						maxinputfuzzytruth = fuzzytruth[q];				//to get the max.probability for each vector
						
					}				
				}



				//--------------End Classifying Function---------------------------------
				/*****************************************************************/
				//-----Find the aveage distance between each vector in Cluster - --

				
				sigma = 0;
				sum = 0;				
				
				for (i=0;i<TotalVectors-1;i++)
				{
					for (ii=i+1;ii<TotalVectors;ii++)
					{	
						dist = 0;
						for (n=0;n<N;n++)
						{	
							dist = dist + Math.Pow((v[i,n] - v[ii,n]),2);
						}
						sum= sum + Math.Sqrt(dist);
					}				
				
					dave = sum /(TotalVectors * (TotalVectors-1)/2);
					sigma = 0.8 * dave;					
					
				}
				//-----------------End of Average Distance Calculation----------------------
				//***************************************************************************
				//- - - - - - - -Eliminate Centers too Close to Others - - - ----------------
				/*-------------------Find distance between pairs---------------------------*/
			
				
					for (i=0;i<TotalVectors-1;i++)     //For each unique pair of centers
					{          
						for (ii=i+1;ii<TotalVectors;ii++)
						{
							dist = 0.0;
							for (n=0;n<N;n++) 
							{
								dist = dist + Math.Pow((v[i,n] - v[ii,n]),2);
							}
					
							Dist = Math.Sqrt(dist);

							if (Dist < PNNParameter.s *dave)
							{								
								for (g=ii; g<TotalVectors-1; g++)
								{
									if(fuzzyValue[g]<fuzzyValue[g+1])
									{
										for (n=0;n<N;n++) v[g,n] = v[g+1,n];  //eliminate one vector
										
									}

									else
									{
										for (n=0;n<N;n++) v[g+1,n] = v[g,n];  //eliminate one vector
									}
									
									TotalVectors--;
								
								}
								
							}//if (Dist < PNNParameter.s *dave)
						}//	for (ii=i+1;ii<TotalVectors;ii++)		
					}//	for (i=0;i<TotalVectors-1;i++)							 			
 
				
				//---------------End Eliminaiton Function-------------------------- 
				//*****************************************************************/
				//--------PNN calculation function for training goodness------------
										
				part = 0.0f;
				denu = 0.0f;			
		
				double[]		fuzzyfunction                = new double[1000];
				
				denu = 2*Math.Pow(sigma,2);

				for (q=0;q<Q;q++)
				{	
					maxfuzzyfunction = 0.0;						
					//part = Math.Sqrt(Math.Pow(2*Math.PI,N))*Math.Pow(sigma,N);
										
					sum = 0.0f;						
					
					for (i=0;i<TotalVectors;i++)
					{
						dist = 0;						
						
						for (n=0;n<N;n++)
						{
							dist = dist + Math.Pow((x[q,n]-v[i,n]),2);
						}

						fuzzyfunction[i]  = fuzzyValue[i] * Math.Exp(-dist/denu);
							
						
						if (fuzzyfunction[i] >maxfuzzyfunction)
						{
							maxfuzzyfunction = fuzzyfunction[i] ;				//to get the max.probability for each vector
							
						}
							
					}					
						p[q] = maxfuzzyfunction;	
								
				}
							
			
				//----------Assign the vector to the cluster according to the probability------------------------------------------------------------------
     	   
				this.textBox4.AppendText(" " + "Vector No." + "      " + "Fuzzy Target " + "     " + " Training Fuzzy Beliefs " + NewLine + Return);
			
				//this.textBox4.AppendText(" " + "Vector No." + "        " + "Class No. " + "   " + " Training Fuzzy Beliefs " + NewLine + Return);
				this.textBox4.AppendText("----------------------------------------------------------" + NewLine + Return);
							
				sumerror = 0;
				
				for (q=0;q<Q;q++)
				{   
										
					if (q<9)
					{
						this.textBox4.AppendText("          " + Convert.ToString(q+1));
				
					}

					else if (q<99)
					{
						this.textBox4.AppendText("        " + Convert.ToString(q+1));

					}

					else if (q<999)
					{
						this.textBox4.AppendText("      " + Convert.ToString(q+1));

					}						
					
				
					this.textBox4.AppendText("                  " + Convert.ToString(String.Format("{0:0.00}",fuzzytruth[q])));
									
					FitCluster[q] = p[q];

					sumerror = sumerror + Math.Pow((p[q] - fuzzytruth[q]),2);
					
					this.textBox4.AppendText("                   " + Convert.ToString(String.Format("{0:0.00000}" , (FitCluster[q]))));
					this.textBox4.AppendText("" + NewLine + Return);
						
					if (FitCluster[q] < MinGoodness)
					{
						MinGoodness = FitCluster[q];
							
					}	
		
					if (FitCluster[q] > MaxGoodness)
					{
						MaxGoodness = FitCluster[q];
							
					}					
						
					checkstatus =1;										
										  		  		  
				}

				SSE = sumerror;
				MSE = sumerror/Q; 				
				
				this.textBox4.AppendText("----------------------------------------------------------"+ NewLine + Return);	
				
				this.textBox4.AppendText(" PNN Training Overall-Measures : " + NewLine + Return);
				this.textBox4.AppendText(" Minimum Fit to Class : " + Convert.ToString(String.Format("{0:0.00000}", MinGoodness))+ NewLine + Return);
				this.textBox4.AppendText(" Maximum Fit to Class : " +Convert.ToString(String.Format("{0:0.00000}", MaxGoodness)) + NewLine + Return);
				this.textBox4.AppendText(" MSE = " +Convert.ToString(String.Format("{0:0.00000}", MSE)) + NewLine + Return);
				this.textBox4.AppendText(" SSE = " +Convert.ToString(String.Format("{0:0.00000}", SSE)) + NewLine + Return);

			}

			else
				MessageBox.Show(" Please input valid files before running !" );
			

		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			textBox4.Clear();
			saveFileDialog1.Filter = "prb Files (*.prb)|*.prb|All files (*.*)|*.*" ;
			
			if(saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				textBox3.Text = saveFileDialog1.FileName;
				outFile = saveFileDialog1.FileName;

				this.textBox4.AppendText("The Result of the probability function valure for each vector will be saved in the following file : "+ NewLine+Return + NewLine + Return);
				this.textBox4.AppendText(""+ textBox3.Text + NewLine + Return+NewLine + Return);
				this.textBox4.AppendText("Please click Run button! "+ NewLine+Return);

				checkit2 =1;
				
			}

			else checkit2 =0;
			
		}

		private void groupBox1_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			PNNTrainingInstruction dlg = new PNNTrainingInstruction();
			dlg.ShowDialog();
		}

		private void textBox2_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void button7_Click(object sender, System.EventArgs e)
		{
			PNNTrainingResult dlg1 = new PNNTrainingResult();
			dlg1.ShowDialog();
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void radioButton1_CheckedChanged(object sender, System.EventArgs e)
		{
		
		}

		private void groupBox3_Enter_1(object sender, System.EventArgs e)
		{
		
		}
	}
}
