using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.IO;

namespace GeoXplore
{
	/// <summary>
	/// Summary description for FuzzyTrainFunctions.
	/// </summary>
	public class FuzzyTrainFunctions : System.Windows.Forms.Form
	{		
		int			    k,kmin,n,q;
	
		double          minD,d; 


	    double[,]		num_cluster			= new double[300,1000];
		double[]        count               = new double[1000];
		
		char			NewLine				= (char)13;
		char			Return				= (char)10;			
		
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Button button6;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FuzzyTrainFunctions()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			textBox1.Clear();
			FuzzyFunctions.kmeans();
			
			this.textBox1.AppendText(" Number of Clusters : " + Convert.ToString(FuzzyFunctions.K));
			this.textBox1.AppendText(" " + NewLine + Return + NewLine + Return);
			for(int k=0;k<FuzzyFunctions.K;k++)
			{
				this.textBox1.AppendText(" Cluster [ " + Convert.ToString(k+1) + " ] "); 
				this.textBox1.AppendText(" has " + Convert.ToString(FuzzyFunctions.count[k]) + " Vectors" +NewLine + Return);				

			}		

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FuzzyTrainFunctions));
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.button2 = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.button6 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBox1
			// 
			this.groupBox1.BackColor = System.Drawing.Color.Transparent;
			this.groupBox1.Controls.Add(this.label5);
			this.groupBox1.Controls.Add(this.label4);
			this.groupBox1.Controls.Add(this.label3);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.button2);
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Controls.Add(this.button4);
			this.groupBox1.Controls.Add(this.button5);
			this.groupBox1.Controls.Add(this.button6);
			this.groupBox1.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.groupBox1.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox1.ForeColor = System.Drawing.Color.Black;
			this.groupBox1.Location = new System.Drawing.Point(24, 24);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(232, 360);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = " Make a selection !";
			// 
			// label5
			// 
			this.label5.ForeColor = System.Drawing.Color.Black;
			this.label5.Location = new System.Drawing.Point(16, 304);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(8, 23);
			this.label5.TabIndex = 10;
			this.label5.Text = "5";
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label4
			// 
			this.label4.ForeColor = System.Drawing.Color.Black;
			this.label4.Location = new System.Drawing.Point(16, 247);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(8, 23);
			this.label4.TabIndex = 9;
			this.label4.Text = "4";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label3
			// 
			this.label3.ForeColor = System.Drawing.Color.Black;
			this.label3.Location = new System.Drawing.Point(16, 168);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(8, 23);
			this.label3.TabIndex = 8;
			this.label3.Text = "3";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label2
			// 
			this.label2.ForeColor = System.Drawing.Color.Black;
			this.label2.Location = new System.Drawing.Point(16, 104);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(8, 23);
			this.label2.TabIndex = 7;
			this.label2.Text = "2";
			this.label2.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
			// 
			// label1
			// 
			this.label1.ForeColor = System.Drawing.Color.Black;
			this.label1.ImageAlign = System.Drawing.ContentAlignment.BottomCenter;
			this.label1.Location = new System.Drawing.Point(16, 40);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(8, 23);
			this.label1.TabIndex = 6;
			this.label1.Text = "1";
			this.label1.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
			// 
			// button2
			// 
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button2.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button2.ForeColor = System.Drawing.Color.Black;
			this.button2.Location = new System.Drawing.Point(40, 168);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(160, 40);
			this.button2.TabIndex = 1;
			this.button2.Text = "Merge and Fuzzy Clustering";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button1.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.ForeColor = System.Drawing.Color.Black;
			this.button1.Location = new System.Drawing.Point(40, 40);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(160, 40);
			this.button1.TabIndex = 0;
			this.button1.Text = "Eliminate Small Clusters";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button4
			// 
			this.button4.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button4.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button4.ForeColor = System.Drawing.Color.Black;
			this.button4.Location = new System.Drawing.Point(40, 104);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(160, 40);
			this.button4.TabIndex = 3;
			this.button4.Text = "Fuzzy Clustering";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// button5
			// 
			this.button5.BackColor = System.Drawing.Color.Transparent;
			this.button5.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button5.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button5.ForeColor = System.Drawing.Color.Black;
			this.button5.Location = new System.Drawing.Point(40, 232);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(160, 40);
			this.button5.TabIndex = 4;
			this.button5.Text = "Save Training Results";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// button6
			// 
			this.button6.BackColor = System.Drawing.Color.Transparent;
			this.button6.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button6.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button6.ForeColor = System.Drawing.Color.Black;
			this.button6.Location = new System.Drawing.Point(40, 296);
			this.button6.Name = "button6";
			this.button6.Size = new System.Drawing.Size(160, 40);
			this.button6.TabIndex = 5;
			this.button6.Text = "Return";
			this.button6.Click += new System.EventHandler(this.button6_Click);
			// 
			// textBox1
			// 
			this.textBox1.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
			this.textBox1.Font = new System.Drawing.Font("Times New Roman", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox1.Location = new System.Drawing.Point(296, 64);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox1.Size = new System.Drawing.Size(424, 320);
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "";
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// label6
			// 
			this.label6.BackColor = System.Drawing.Color.Transparent;
			this.label6.Font = new System.Drawing.Font("Times New Roman", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label6.Location = new System.Drawing.Point(296, 32);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(432, 23);
			this.label6.TabIndex = 15;
			this.label6.Text = " The Fuzzy Clustering  training results will  be shown in this box";
			// 
			// FuzzyTrainFunctions
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(768, 446);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.groupBox1);
			this.Font = new System.Drawing.Font("Times New Roman", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "FuzzyTrainFunctions";
			this.Text = "Fuzzy Train Functions";
			this.Load += new System.EventHandler(this.FuzzyTrainFunctions_Load);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void button6_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			textBox1.Clear();			
			FuzzyFunctions.elimps();
			FuzzyFunctions.kmeans();     //Reassign vectors from eliminated clusters
			
			this.textBox1.AppendText(" Number of Clusters : " + Convert.ToString(FuzzyFunctions.K));
			this.textBox1.AppendText(" " + NewLine + Return + NewLine + Return);
			for(int k=0;k<FuzzyFunctions.K;k++)
			{
				this.textBox1.AppendText(" Cluster [ " + Convert.ToString(k+1) + " ] "); 
				this.textBox1.AppendText(" has " + Convert.ToString(FuzzyFunctions.count[k]) + " Vectors" +NewLine + Return);				

			}
			
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			FuzzyTrainingParameter dlg = new FuzzyTrainingParameter();
			dlg.ShowDialog();

		    textBox1.Clear();
			FuzzyFunctions.merge ();
			FuzzyFunctions.kmeans();
			FuzzyFunctions.fuzcl();      //do fuzzy clustering with fuzzy prototypes			
			
            
			if (FuzzyFunctions.K < 4)
			{
				this.textBox1.AppendText("    Vector No. " + "     Cluster No. " + NewLine + Return );
				
				for (k=0;k<FuzzyFunctions.K;k++) 
				{
					
					for (q = 0; q < FuzzyFunctions.Q; q++)
					{
						num_cluster[k,q] = 0;
					}
				}

				for (q=0;q<FuzzyFunctions.Q;q++)                //For each qth vector x(q)
				{
					minD = 999999.9;
    
					for (k=0;k<FuzzyFunctions.K;k++)              //and each kth cluster center
					{
						d = 0.0;
						for (n=0;n<FuzzyFunctions.N;n++) d = d + Math.Pow(FuzzyFunctions.v[k,n] - FuzzyFunctions.x[q,n],2);
						if (d < minD)                //find distance and assign
						{
							minD = d; 
							kmin = k;        //x(q) to cluster by min. dist.						
						}
						
					}
					if (q<9)
					{
						this.textBox1.AppendText("            " + Convert.ToString(q+1));
					}
					else
					{
						this.textBox1.AppendText("          " + Convert.ToString(q+1));
					}					
					
					this.textBox1.AppendText("                    " + Convert.ToString(kmin+1) + NewLine + Return);
 																
								
				}	
			
			}
			
			this.textBox1.AppendText("----------------------------------------------------" + NewLine + Return);
			
			for (k=0;k<FuzzyFunctions.K;k++)
			{
				this.textBox1.AppendText(" Cluster "+ Convert.ToString(k+1) + " has " + Convert.ToString(FuzzyFunctions.count[k]) + " vectors. ");
						
				this.textBox1.AppendText(" "+ NewLine+Return);
		
			} 	

			this.textBox1.AppendText(" "+ NewLine+Return);

			for(k=0;k<FuzzyFunctions.K;k++)
			{
				this.textBox1.AppendText(" Cluster Center [ " + Convert.ToString(k+1)+ " ] = ");
							
				for (n=0; n<FuzzyFunctions.N; n++)
				{
					this.textBox1.AppendText(Convert.ToString(Math.Round(FuzzyFunctions.v[k,n],2)));
					this.textBox1.AppendText(" ");
	
				}	
				this.textBox1.AppendText("   " + NewLine + Return);
			}
			
			this.textBox1.AppendText("" + NewLine + Return);

			for(k=0;k<FuzzyFunctions.K;k++)
		
			{
				this.textBox1.AppendText(" Variance of Cluster [ " +Convert.ToString(k+1)+ " ] is " + Convert.ToString(Math.Round(Math.Sqrt(FuzzyFunctions.sig2[k]),2)) + NewLine + Return);
			
			}
			this.textBox1.AppendText("------------------------------------------------------" + NewLine + Return);

			this.textBox1.AppendText(" Number of Clusters : " + Convert.ToString(FuzzyFunctions.K) + "      " + "Clustering Validity :  " + Convert.ToString(Math.Round(FuzzyFunctions.CVAL,3)));
			this.textBox1.AppendText("" + NewLine + Return);

		}

		private void button3_Click(object sender, System.EventArgs e)
		{			
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			textBox1.Clear();		
			
			FuzzyFunctions.fuzcl();      //do fuzzy clustering with fuzzy prototypes
					
			
			this.textBox1.AppendText(" Number of Clusters : " + Convert.ToString(FuzzyFunctions.K));
			this.textBox1.AppendText(" " + NewLine + Return + NewLine + Return);
			
			for (k=0;k<FuzzyFunctions.K;k++)
			{
				this.textBox1.AppendText(" Cluster "+ Convert.ToString(k+1) + " has " + Convert.ToString(FuzzyFunctions.count[k]) + " vectors. ");
						
				this.textBox1.AppendText(" "+ NewLine+Return);
		
			} 	
		
			this.textBox1.AppendText(" "+ NewLine+Return);
			
			

			for(k=0;k<FuzzyFunctions.K;k++)
			{
				this.textBox1.AppendText(" Cluster Center [ " + Convert.ToString(k+1)+ " ] = ");
							
				for (n=0; n<FuzzyFunctions.N; n++)
				{
					this.textBox1.AppendText(Convert.ToString(Math.Round(FuzzyFunctions.v[k,n],2)));
					this.textBox1.AppendText(" ");
	
				}	
       	        this.textBox1.AppendText("   " + NewLine + Return);
			}
			
			this.textBox1.AppendText("" + NewLine + Return);

			for(k=0;k<FuzzyFunctions.K;k++)
		
			{
				this.textBox1.AppendText(" Variance of Cluster [ " +Convert.ToString(k+1)+ " ] is " + Convert.ToString(Math.Round(Math.Sqrt(FuzzyFunctions.sig2[k]),2)) + NewLine + Return);
			
			}

			this.textBox1.AppendText("--------------------------------------------------" + NewLine + Return);
			
			this.textBox1.AppendText(" Number of Clusters : " + Convert.ToString(FuzzyFunctions.K) + "      " + "Clustering Validity :  " + Convert.ToString(Math.Round(FuzzyFunctions.CVAL,3)));
			this.textBox1.AppendText("" + NewLine + Return);

		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			FuzzyTrainingResult dlg = new FuzzyTrainingResult();
			dlg.ShowDialog();			
			
		}

		private void FuzzyTrainFunctions_Load(object sender, System.EventArgs e)
		{
		
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
		
		}
	}
}
