using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.IO;

namespace GeoXplore
{
	/// <summary>
	/// Summary description for FuzzyTrainingResult.
	/// </summary>
	public class FuzzyTrainingResult : System.Windows.Forms.Form
	{
		
		int k,n,q;
		
		char			NewLine				= (char)13;
		char			Return				= (char)10;			
		
		
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.Label label6;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FuzzyTrainingResult()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			textBox1.Clear();			
			
			this.textBox1.AppendText(Convert.ToString(FuzzyFunctions.N)+ NewLine + Return);
			this.textBox1.AppendText(Convert.ToString(FuzzyFunctions.K) + NewLine + Return);

			for (k=0;k<FuzzyFunctions.K;k++)
			{
				for (n=0;n<FuzzyFunctions.N;n++)
				{
					this.textBox1.AppendText( Convert.ToString(Math.Round(FuzzyFunctions.v[k,n],2))+ " " );
				}
				this.textBox1.AppendText("" + NewLine + Return);
			}

			for(k=0;k<FuzzyFunctions.K;k++)
		
			{
				this.textBox1.AppendText(Convert.ToString(Math.Round(Math.Sqrt(FuzzyFunctions.sig2[k]),2)) + NewLine + Return);
			
			}

			for(q=0;q<FuzzyFunctions.Q;q++)
			{
			
				this.textBox1.AppendText(Convert.ToString(Math.Round(Math.Sqrt(FuzzyFunctions.fuzzytruth[q]),2)) + NewLine + Return);
			
			}
			


			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FuzzyTrainingResult));
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.label6 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
			this.textBox1.Font = new System.Drawing.Font("Times New Roman", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox1.Location = new System.Drawing.Point(24, 56);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox1.Size = new System.Drawing.Size(32, 16);
			this.textBox1.TabIndex = 2;
			this.textBox1.Text = "";
			this.textBox1.Visible = false;
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// button1
			// 
			this.button1.BackColor = System.Drawing.Color.Transparent;
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button1.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.ForeColor = System.Drawing.Color.Black;
			this.button1.Location = new System.Drawing.Point(112, 64);
			this.button1.Name = "button1";
			this.button1.TabIndex = 3;
			this.button1.Text = "Return";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label6
			// 
			this.label6.BackColor = System.Drawing.Color.Transparent;
			this.label6.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label6.ForeColor = System.Drawing.Color.Black;
			this.label6.Location = new System.Drawing.Point(8, 24);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(304, 23);
			this.label6.TabIndex = 16;
			this.label6.Text = " The fuzzy clustering training results have been saved  !";
			// 
			// FuzzyTrainingResult
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(322, 112);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.textBox1);
			this.Font = new System.Drawing.Font("Times New Roman", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ForeColor = System.Drawing.Color.DarkBlue;
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "FuzzyTrainingResult";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Fuzzy Clustering Training Result";
			this.Load += new System.EventHandler(this.FuzzyTrainingResult_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void button2_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//---------------------------save the result to the output file----------------------			
			// get name of selected output file
						
			FileStream outStream = new FileStream(FuzzyTrain.outFile,FileMode.OpenOrCreate);

			// define writer to write stream to output file
			//StreamWriter writer = new StreamWriter(outStream,Encoding.ASCII);
			StreamWriter writer = new StreamWriter(outStream);
			
			string inText = this.textBox1.Text;
			outStream.Seek(0,SeekOrigin.Begin);
			writer.Write(inText);
			writer.Flush();  
			

			// close output stream
			writer.Close();
			outStream.Close();			
			
			this.Close();
		}

		private void FuzzyTrainingResult_Load(object sender, System.EventArgs e)
		{
		
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
		
		}
	}
}
